﻿namespace WFAAdapters;

interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Windows.Forms,
  System.Data,
  System.Data.SqlClient,
  System.ComponentModel;

type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>
  MainForm = partial class(System.Windows.Forms.Form)
  private
     var xsqlCn:SqlConnection := new SqlConnection();
     var xsqlCm:SqlCommand := new SqlCommand();
     var xsqlDa:SqlDataAdapter:= new SqlDataAdapter();
     var xdsContato:  DataSet := new DataSet();
     method LoadTable;
      method MainForm_Load(sender: System.Object; e: System.EventArgs);
      method toolStripButton1_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton2_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton3_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton4_Click(sender: System.Object; e: System.EventArgs);
      method toolStripButton5_Click(sender: System.Object; e: System.EventArgs);
      method dataGridView1_CellClick(sender: System.Object; e: System.Windows.Forms.DataGridViewCellEventArgs);
  protected
    method Dispose(disposing: Boolean); override;
  public
    constructor;
  end;

implementation

{$REGION Construction and Disposition}
constructor MainForm;
begin
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent();

  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

method MainForm.Dispose(disposing: Boolean);
begin
  if disposing then begin
    if assigned(components) then
      components.Dispose();

    //
    // TODO: Add custom disposition code here
    //
  end;
  inherited Dispose(disposing);
end;
{$ENDREGION}

method MainForm.LoadTable;
begin
   {$Region Criar a conexão}  
          
    if (xsqlCn.State <> ConnectionState.Open) then
    begin
        xsqlCn.ConnectionString := "Data Source=Technologies\sql2008;" +
            "Initial Catalog=AdventureWorks; "+
            "Integrated Security=true;"+
            "User Id=sa; Password=997220201";
        xsqlCn.Open();
    end;            
    
    {$endregion}

    {$Region Preparar o commad}            
    xsqlCm.Connection := xsqlCn;
    xsqlCm.CommandType := CommandType.Text;
    xsqlCm.CommandText := "SELECT TOP 1000 
                           [ContactID]
                          ,[FirstName]
                          ,[LastName]      
                      FROM [AdventureWorks].[Person].[Contact]";
    {$endregion}

    {$Region Preparar o adapter}            
    xsqlDa.SelectCommand := xsqlCm;
    {$endregion}

    {$Region Preencher o DataSet}
    xdsContato.Clear();
    xsqlDa.Fill(xdsContato, "Contato");           
    {$endregion}

    {$Region Visualizar os dados}
    dataGridView1.DataSource := xdsContato.Tables[0];
    dataGridView1.ReadOnly := true;
    {$endregion};
end;

method MainForm.MainForm_Load(sender: System.Object; e: System.EventArgs);
begin
  LoadTable;
end;

method MainForm.toolStripButton1_Click(sender: System.Object; e: System.EventArgs);
begin
    {$Region Adicionar registros}
    var  xdr:DataRow := xdsContato.Tables[0].NewRow();
    xdr["ContactID"] := tbxCodigo.Text;
    xdr["FirstName"] := tbxNome.Text;
    xdr["LastName"] := tbxSobrenome.Text;
    xdsContato.Tables[0].Rows.Add(xdr);

    tbxCodigo.Clear();
    tbxNome.Clear();
    tbxSobrenome.Clear();
    {$endregion}
end;

method MainForm.toolStripButton2_Click(sender: System.Object; e: System.EventArgs);
begin
    {$Region Gravar registro}
    xdsContato.Tables[0].Rows[dataGridView1.CurrentRow.Index]["ContactID"]:= 
    tbxCodigo.Text;
            
    xdsContato.Tables[0].Rows[dataGridView1.CurrentRow.Index]["FirstName"]:= 
    tbxNome.Text;
            
    xdsContato.Tables[0].Rows[dataGridView1.CurrentRow.Index]["LastName"]:= 
    tbxSobrenome.Text;
    {$endregion}
end;

method MainForm.toolStripButton3_Click(sender: System.Object; e: System.EventArgs);
begin
    {$Region Excluir registro}
    if (xdsContato.Tables[0].Rows.Count = 0) then exit;
    xdsContato.Tables[0].Rows[dataGridView1.CurrentRow.Index].Delete();
    {$endregion};
end;

method MainForm.toolStripButton4_Click(sender: System.Object; e: System.EventArgs);
begin
    {$Region Criar uma instância do CommandBuilder}
    var xsqlBuilder:SqlCommandBuilder:= new SqlCommandBuilder(xsqlDa);
    xsqlBuilder.SetAllValues := false;
    {$endregion}
            
    {$Region Gerar instrução sql insert}
    xsqlDa.InsertCommand:=xsqlBuilder.GetInsertCommand();
    xsqlDa.Update(xdsContato,xdsContato.Tables[0].TableName);
    lbxSql.Items.Add(xsqlDa.InsertCommand.CommandText);
    lbxSql.Items.Add("");
    {$endregion}

    {$Region Gerar instrução sql update}
    xsqlDa.UpdateCommand := xsqlBuilder.GetUpdateCommand();
    xsqlDa.Update(xdsContato, xdsContato.Tables[0].TableName);
    lbxSql.Items.Add(xsqlDa.UpdateCommand.CommandText);
    lbxSql.Items.Add("");
    {$endregion}

    {$Region Gerar instrução sql delete}
    xsqlDa.DeleteCommand := xsqlBuilder.GetDeleteCommand();
    xsqlDa.Update(xdsContato, xdsContato.Tables[0].TableName);
    lbxSql.Items.Add(xsqlDa.DeleteCommand.CommandText);
    lbxSql.Items.Add("");
    {$endregion}
end;

method MainForm.toolStripButton5_Click(sender: System.Object; e: System.EventArgs);
begin
  LoadTable();
end;

method MainForm.dataGridView1_CellClick(sender: System.Object; e: System.Windows.Forms.DataGridViewCellEventArgs);
begin
    {$Region Editar registro}
    if ((xdsContato.Tables[0].Rows.Count=0)) then exit;

    tbxCodigo.Text := 
    xdsContato.Tables[0].Rows[dataGridView1.CurrentRow.Index]["ContactID"].ToString();
            
    tbxNome.Text := 
    xdsContato.Tables[0].Rows[dataGridView1.CurrentRow.Index]["FirstName"].ToString();
            
    tbxSobrenome.Text := 
    xdsContato.Tables[0].Rows[dataGridView1.CurrentRow.Index]["LastName"].ToString();
    {$endregion}
end;

end.
