unit uMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Forms, FMX.Dialogs, FMX.Ani, FMX.Controls, FMX.Objects, FMX.Effects, FMX.Filter.Effects, FMX.Menus, FMX.Layouts, FMX.ListBox;

type
  TForm1 = class(TForm)
    StyleBook1: TStyleBook;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    ListBox1: TListBox;
    Button7: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.Button1Click(Sender: TObject);
var
  aBase: TFmxObject;
begin
  aBase := Panel1.FindStyleResource('Foto');
  // O executvel fica no diretrio .\Win32\Debug
  if aBase is TImage then
    TImage(aBase).Bitmap.LoadFromFile('..\..\P1.JPG');

  TText(Panel1.FindStyleResource('Nome')).Text := 'Darth Vader';
  TText(Panel1.FindStyleResource('Matricula')).Text := '010001-0';
  TText(Panel1.FindStyleResource('CodBarras')).Text := '*010001-0*';
  TText(Panel1.FindStyleResource('DtNasc')).Text := '01/03/1973';
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  with TGlowEffect(Panel1.FindStyleResource('EfeitoFoto')) do
    if GlowColor = TAlphaColorRec.Blue then
      GlowColor := TAlphaColorRec.Red
    else
      GlowColor := TAlphaColorRec.Blue;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  with TReflectionEffect(Panel1.FindStyleResource('ReflexoFoto')) do
    Enabled := not Enabled;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if Panel1.Scale.X = 1 then
    Panel1.Scale.X := 1.5
  else
    Panel1.Scale.X := 1;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Panel1.RotationAngle := Panel1.RotationAngle - 30;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  Panel1.RotationCenter.X := 1;
  Panel1.RotationCenter.y := 1;
  Panel1.RotationAngle := Panel1.RotationAngle - 30;
end;

procedure TForm1.Button7Click(Sender: TObject);
const
  kDados: array[0..6,0..2] of string =
    ( ('P1.JPG', 'Darth Vader',   '010001-0'),
      ('P2.JPG', 'Luke Skywalker','020001-9'),
      ('P3.JPG', 'Leia Organa',   '020002-7'),
      ('P4.JPG', 'R2-D2',         '020003-5'),
      ('P5.JPG', 'C-3PO',         '020004-3'),
      ('P6.JPG', 'Chewbacca',     '020005-1'),
      ('P7.JPG', 'Han Solo',      '020006-8') );

var
  i: Integer;
  aItem: TListBoxItem;
  aBase: TFmxObject;
  aCor: TAlphaColor;
begin
  ListBox1.ItemHeight := 202;

  for i := 0 to 6 do
  begin
    aItem := TListBoxItem.Create(nil);
    aItem.Parent := ListBox1;
    aItem.StyleLookup := 'carteira';

    aBase := aItem.FindStyleResource('Foto');
    // O executvel fica no diretrio .\Win32\Debug e os fontes dois diretrios acima
    if aBase is TImage then
      TImage(aBase).Bitmap.LoadFromFile('..\..\'+kDados[i,0]);

    TText(aItem.FindStyleResource('Nome')).Text := kDados[i,1];
    TText(aItem.FindStyleResource('Matricula')).Text := kDados[i,2];
    TText(aItem.FindStyleResource('CodBarras')).Text := '*'+kDados[i,2]+'*';

    //  Se a matrcula comear com '01'  do time do mal
    if Copy(kDados[i,2],1,2) = '01' then
      aCor := TAlphaColorRec.Red
    else
      aCor := TAlphaColorRec.Blue;
    TGlowEffect(aItem.FindStyleResource('EfeitoFoto')).GlowColor := aCor;
  end;
end;

end.
